#pragma once

const int kThroughWall_BUFFID = 6003;
const int FLY_BUFFID = 7001;
const int JUMP_BUFFID = 7002;
const int DRIVER_BUFFID = 7003;
const int PASSENGER_BUFFID = 7004;
const int kRecoilBuffId = 7005;
const int kInGrassBuffId = 7006;
const int kInWaterBuffId = 7007;
const int kInIceBuffId = 7008;
const int kBeRecycleBuffId = 7009;
const int kTraceBuffId = 7011;
const int kInMountainTopBuffId = 7014;
const int kDownBuffId = 7015;
const int kPoisioningBuffId = 7016;
const int kRescueBuffId = 7017;
const int kVertigoBuffId = 7018;
const int kPeaceModeBuffId = 7019;
const int kPullToWalkableBuffId = 8003;
const int kDiveBuffId = 8054;

enum BuffEffectType_e
{
    kBET_Begin = 0,
    kBET_ChgAttr = 1, //改变属性
    kBET_TurnOver = 2, //翻滚
    kBET_Car = 3, //骑乘
    kBET_Invincible = 4, //无敌
    kBET_Camouflage = 5, //伪装
    kBET_AdPlaying = 6, //看广告中
    kBET_LordMode = 7, //上帝模式
    kBET_NewProtect = 8, //新手保护血量低于50%
    kBET_BePull = 9, //拉人(被拉方)
    kBET_JumpTo = 10, //跳跃
    kBET_OnceChgAttr = 11, //一次性buff
    kBET_Pull = 12, //拉人(主动方)
    kBET_Terminator = 13, //终结者模式
    kBET_PlayShotAni = 14, //播放射击动画
    kBET_Vertigo = 15, //眩晕
    kBET_DecHp = 16, //扣血
    kBET_PullDone = 17, //拖拽到目的地
    kBET_DelayAddBuff = 18, //延迟加buff
    kBET_PlayEffect = 19, //播放特效（客户端表现用）
    kBET_CliEffect2 = 20, //僵尸被动光环毒物（客户端表现用）
    kBET_CliEffect3 = 21, //僵尸被动光环地震(客户端表现用)
    kBET_CliEffect4 = 22, //被拖拽(客户端表现用)
    kBET_HunLuan = 23, //混乱,在烟雾弹中不自动瞄准
    kBET_Fly = 24, //飞行中
    kBET_Jump = 25, //跳伞中
    kBET_IntervalAddBuff = 26, //持续掉血
    //kBET_LastAddHp = 27, //持续加血
    kBET_OnceAddHp = 28, //加血
    kBET_SummonHero = 29, //召唤英雄
    //kBET_SummonHero = 30, //向前跳跃
    kBET_Shield = 31, //护盾
    kBET_Hide = 32, //隐身
    kBET_CrazyMode = 33, //暴走模式
    kBET_ShockWave = 34, //冲击波
    kBET_Sprint = 35, //冲刺
    kBET_SummonObstacle = 36, //召唤物件
    kBET_FlashMove = 37, //瞬间移动
    kBET_Become = 38, //变身
    kBET_ShotCharge = 39, //射击蓄力
    kBET_SelectTargetWithSelfPos = 40, //已自己坐标为中心范围内选取目标,并且批量添加buff
    kBET_CondAddBuff = 41, //条件添加buff
    kBET_AddInventory = 42, //扩充库存
    kBET_Down = 43, //倒下
    kBET_Poisoning = 44, //中毒（毒圈中）
    kBET_Rescue = 45, //救援
    kBET_AddCarBuff = 46, //给载具加buff
    kBET_RemoveCarBuff = 47, //移除载具身上的buff
    kBET_BulletThrough = 48, //穿透

    kBET_FollowMaster = 49, //跟随主人
    kBET_ThroughWall = 50, //穿墙
    kBET_Driver = 51, //驾驶中
    kBET_Passenger = 52, //乘座中
    kBET_CarActive = 53, //激活载具
    kBET_CarDeactive = 54, //载具待机
    kBET_Recoil = 55, //后坐力
    kBET_InGrass = 56, //在草丛
    kBET_InWater = 57, //在水里
    kBET_InIce = 58, //在冰里
    kBET_PullToWalkable = 59, //从碰撞里以自己方向拖出来直到没有碰撞
    kBET_BatchAddBuff = 60, //批量添加buff
    kBET_BeRecycle = 61, //待回收
    kBET_Trace = 62, //追踪玩家
    kBET_MountainTop = 63, //在山顶
    kBET_UseSkill = 64, //使用技能
    kBET_CamouflageAddition = 65, //对抗伪装
    kBET_AutoShot = 66, //自动射击
    kBET_BeatBack = 67, //击退
    kBET_Disperse = 68, //驱散
    kBET_PeaceMode = 69, //和平模式
    kBET_ClientUse1 = 70, //
    kBET_ClientUse2 = 71, //
    kBET_Dive = 72, //下潜模式

    kBET_End
};

enum EntityType_e
{
   ET_None = 0,
   ET_Player = 1,
   ET_Obstacle = 2,
   ET_Building = 3,
   //ET_LootSpawner = 4,
   ET_Loot = 5,
   //ET_DeadBody = 6,
   //ET_Decal = 7,
   //ET_Projectile = 8,
   //ET_Smoke = 9,
   ET_Hero = 10,
   ET_Car = 11,

   ET_Bullet = 20,

   ET_MapBlock = 28,
   ET_Dummy = 29,
   ET_Unuse = 30,
   ET_MAX
};

enum AIKind_e
{
   kAI_Begin = 0,
   kAI_Android = 1,
   kAI_MineSweeper = 2,
   kAI_End
};
