#pragma once

#include "weakptr.h"

struct PartObject
{
    int entity_uniid = 0;
    int entity_type = 0;
    int entity_subtype = 0;
    long long add_frameno = 0;
    EntityWeakPtr object;
};

class Human;
class FrameData
{
 private:
    void ClearFrameData(Human* hum);

 private:
    std::map<int, EntityWeakPtr> new_objects;
    std::map<int, EntityWeakPtr> block_objects;
    std::map<int, EntityWeakPtr> loot_objects;
    std::map<int, PartObject> part_objects;
    std::set<int> del_objects;
    std::set<int> out_objects;
    std::vector<int> shots_;
    std::vector<int> emotes_;
    std::vector<int> bullets_;
    std::vector<int> smokes_;
    std::vector<int> play_skills_;
    std::vector<int> explosions_;
    std::vector<int> chged_buffs_;
    std::vector<int> chged_bullet_nums_;
    std::vector<int> chged_hps_;
    std::vector<int> chged_skillcds_;
    std::vector<int> chged_skill_curr_times_;
    std::vector<int> chged_items_;
    std::vector<int> chged_weapon_ammo_;
    std::vector<int> dead_alive_objs_;
    std::vector<int> chged_cars_;
    std::vector<int> chged_props_;
    std::vector<int> del_bullets_;

    friend class Human;
    friend class FrameMaker;
    friend class FrameEvent;
};
