#pragma once

namespace cs
{
    class CMJoin;
    class CMReconnect;
    class CMMatchCancel;
    class CMMatchChoose;
    class CMMatchStartGame;
    class CMMatchCancelStartGame;
    class CMMatchSendMsg;
    class CMMatchBroadcastMsg;
}

class MatchTeam;
class MatchMgr : public a8::Singleton<MatchMgr>
{
 public:
    enum { HID = HID_MatchMgr };

 private:
    MatchMgr() {};
    friend class a8::Singleton<MatchMgr>;

public:
    a8::TimerAttacher timer_attacher;

    void Init();
    void UnInit();

    void _CMJoin(f8::MsgHdr& hdr, const cs::CMJoin& msg);
    void _CMMatchCancel(f8::MsgHdr& hdr, const cs::CMMatchCancel& msg);
    void _CMMatchChoose(f8::MsgHdr& hdr, const cs::CMMatchChoose& msg);
    void _CMMatchStartGame(f8::MsgHdr& hdr, const cs::CMMatchStartGame& msg);
    void _CMMatchCancelStartGame(f8::MsgHdr& hdr, const cs::CMMatchCancelStartGame& msg);
    void _CMMatchSendMsg(f8::MsgHdr& hdr, const cs::CMMatchSendMsg& msg);
    void _CMMatchBroadcastMsg(f8::MsgHdr& hdr, const cs::CMMatchBroadcastMsg& msg);
    void TraverseTeam(std::function<void (MatchTeam*, bool&)> func);

    bool NeedMatch(const cs::CMJoin& msg);
    MatchTeam* GetTeam(const std::string& team_uuid);
    std::tuple<std::string, MatchTeam*>* GetMatchInfo(int socket_handle);
    void RemoveTeam(const std::string& team_uuid);
    void RemoveSocket(int socket_handle);
    void Output();

private:
    std::map<std::string, MatchTeam*> team_hash_;
    std::map<int, std::tuple<std::string, MatchTeam*>> socket_hash_;
};
