#pragma once

#include "weakptr.h"
#include "gridservice.h"
#include "obstacle.h"
#include "weakptr.h"

namespace MetaData
{
    struct Buff;
}

class Ability;
class RoomObstacle : public Obstacle
{
 public:
    Room* room = nullptr;
    a8::XTimerAttacher xtimer_attacher;
    bool is_treasure_box = false;
    CreatureWeakPtr master;
    int real_object_uniid = 0;
    std::shared_ptr<Ability> context_ability;
    bool sweep_lock = false;
    MetaData::Buff* buff_meta = nullptr;
    long long born_frameno = 0;

    virtual ~RoomObstacle() override;
    virtual void Initialize() override;
    virtual void RecalcSelfCollider() override;
    virtual bool DoInteraction(Human* sender) override;
    virtual void OnBattleStart(Room* room) override;
    void ActiveTimerFunc();
    void UpdateTimerFunc();
    void Active();
    virtual void Die(Room* room) override;
    Entity* GetRealObject(Room* room);

    RoomObstacleWeakPtrChunk* GetWeakPtrChunk() { return &weak_ptr_chunk_; };
    RoomObstacleWeakPtr AllocWeakPtr();
    RoomObstacleWeakPtr& GetWeakPtrRef();
    void Destory();
    void PushCollisionObjects();

private:
    void SpecExplosion();
    void ActiveSelfExplosion();
    void ActiveMine();
    void ActiveTrap();
    void ActivePosionGas();
    void ActiveSpring();
    void ActiveHideHouse();
    void ActiveGully();
    void ActiveAirDrop();
    void ActiveKeepRangeBuff();

    void SummonAirDropBox(int box_id);
    void ProcKeepRangeBuff();
    void DetachFromMaster();
    void InstallPreExplostionSummonTimer();

protected:
    RoomObstacleWeakPtr weak_ptr_;
    RoomObstacleWeakPtrChunk weak_ptr_chunk_;

    std::set<GridCell*>* grid_list_ = nullptr;
    int explosion_times_ = 0;
    bool detached_ = false;
    std::map<int, CreatureWeakPtr>* hit_objects_ = nullptr;
    std::shared_ptr<std::vector<a8::Vec2>> pos_list;
    int total_explosion_times_ = 0;

    RoomObstacle();

    friend class EntityFactory;
};
